Unit DE07R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTDE18_p;

procedure DE07R(M :Integer; XN :Real; var YN :Array of Real; XK :Real;
                N :Integer; Q :Integer; var A :Array of Real;
                var ALP :Array of Real; var BET :Array of Real;
                JSTART :Integer; var Y :Array of Real;
                var E :Array of Real; var G :Array of Real;
                var A1 :Array of Real; var R :Array of Real;
                var R1 :Array of Real; var IERR :Integer);

implementation

procedure DE07R(M :Integer; XN :Real; var YN :Array of Real; XK :Real;
                N :Integer; Q :Integer; var A :Array of Real;
                var ALP :Array of Real; var BET :Array of Real;
                JSTART :Integer; var Y :Array of Real;
                var E :Array of Real; var G :Array of Real;
                var A1 :Array of Real; var R :Array of Real;
                var R1 :Array of Real; var IERR :Integer);
var
I,I1,IS_,J,L,S :Integer;
H,RA,RA1 :Real;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,
_160,_170,_180,_190,_200,_210,_220,_230,_240,_250,_260,_270,_280,_290,
_300,_310,_320,_330,_340,_350,_360,_370,_380,_390,_400,_410;
begin
IERR := 0;
if ( Q <  1 ) 
 then goto _380;
if ( N <  1 ) 
 then goto _390;
if ( JSTART <>  0 ) 
 then goto _340;
S := Q + 1;
H := (XK - XN)/ (IntPower(2,N));
for I:=1 to M do
 begin
  for J:=1 to M do
   begin
    A1[(I-1)+(J-1)*M] := A[(I-1)+(J-1)*M]*H;
    E[(I-1)+(J-1)*M] := A1[(I-1)+(J-1)*M];
_10:
   end;
_20:
 end;
for L:=1 to M do
 begin
  RA := BET[L-1]*H;
  for I:=1 to M do
   begin
    A1[(I-1)+(I-1)*M] := E[(I-1)+(I-1)*M] - RA;
    G[(I-1)+(L-1)*M] := A1[(I-1)+(L-1)*M];
_30:
   end;
  RA := 1.0 / (S);
  I1 := S - 1;
_40:
  for I:=1 to M do
   begin
    G[(I-1)+(L-1)*M] := G[(I-1)+(L-1)*M]*RA;
_50:
   end;
  G[(L-1)+(L-1)*M] := G[(L-1)+(L-1)*M] + 1.e0;
  if ( I1 =  1 ) 
   then goto _90;
  for I:=1 to M do
   begin
    RA := 0.0;
    for J:=1 to M do
     begin
      RA := RA + A1[(I-1)+(J-1)*M]*G[(J-1)+(L-1)*M];
_60:
     end;
    R[I-1] := RA;
_70:
   end;
  for I:=1 to M do
   begin
    G[(I-1)+(L-1)*M] := R[I-1];
_80:
   end;
  RA := 1.0 / (I1);
  I1 := I1 - 1;
  goto _40;
_90:
  for I:=1 to M do
   begin
    G[(I-1)+(L-1)*M] := G[(I-1)+(L-1)*M]*H;
_100:
   end;
_110:
 end;
for I:=1 to M do
 begin
  for J:=1 to M do
   begin
    A1[(I-1)+(J-1)*M] := E[(I-1)+(J-1)*M];
_120:
   end;
_130:
 end;
if ( S =  1 ) 
 then goto _210;
RA := 1.0 / (S);
I1 := S - 1;
_140:
for I:=1 to M do
 begin
  for J:=1 to M do
   begin
    A1[(I-1)+(J-1)*M] := A1[(I-1)+(J-1)*M]*RA;
_150:
   end;
  A1[(I-1)+(I-1)*M] := A1[(I-1)+(I-1)*M] + 1.0;
_160:
 end;
for L:=1 to M do
 begin
  for I:=1 to M do
   begin
    RA := 0.0;
    for J:=1 to M do
     begin
      RA := RA + E[(I-1)+(J-1)*M]*A1[(J-1)+(L-1)*M];
_170:
     end;
    R[I-1] := RA;
_180:
   end;
  for I:=1 to M do
   begin
    A1[(I-1)+(L-1)*M] := R[I-1];
_190:
   end;
_200:
 end;
RA := 1.0 / (I1);
I1 := I1 - 1;
if ( I1 <>  0 ) 
 then goto _140;
_210:
for I:=1 to M do
 begin
  A1[(I-1)+(I-1)*M] := A1[(I-1)+(I-1)*M] + 1.e0;
_220:
 end;
for IS_:=1 to N do
 begin
  for L:=1 to M do
   begin
    RA := Exp(-BET[L-1]*H);
    for I:=1 to M do
     begin
      for J:=1 to M do
       begin
        R[J-1] := A1[(I-1)+(J-1)*M]*RA;
_230:
       end;
      R[I-1] := R[I-1] + 1.0;
      RA1 := 0.0;
      for J:=1 to M do
       begin
        RA1 := RA1 + R[J-1]*G[(J-1)+(L-1)*M];
_240:
       end;
      R1[I-1] := RA1;
_250:
     end;
    for I:=1 to M do
     begin
      G[(I-1)+(L-1)*M] := R1[I-1];
_260:
     end;
_270:
   end;
  for L:=1 to M do
   begin
    for I:=1 to M do
     begin
      RA := 0.0;
      for J:=1 to M do
       begin
        RA := RA + A1[(I-1)+(J-1)*M]*A1[(J-1)+(L-1)*M];
_280:
       end;
      E[(I-1)+(L-1)*M] := RA;
_290:
     end;
_300:
   end;
  for I:=1 to M do
   begin
    for J:=1 to M do
     begin
      A1[(I-1)+(J-1)*M] := E[(I-1)+(J-1)*M];
_310:
     end;
_320:
   end;
  H := H + H;
_330:
 end;
_340:
for I:=1 to M do
 begin
  R[I-1] := ALP[I-1]* Exp(BET[I-1]*XK);
_350:
 end;
for I:=1 to M do
 begin
  RA := 0.0;
  for J:=1 to M do
   begin
    RA := RA + A1[(I-1)+(J-1)*M]*YN[J-1] + R[J-1]*G[(I-1)+(J-1)*M];
_360:
   end;
  Y[I-1] := RA;
_370:
 end;
goto _410;
_380:
IERR := 66;
goto _400;
_390:
IERR := 65;
_400:
UTDE18(IERR,7);
_410:
end;

end.
